=== debian/changelog ===
cyclonedds (0.9.0-3) unstable; urgency=medium

  * Fix optional symbol for libddsc0 (only with Iceoryx)

 -- Timo Röhling <roehling@debian.org>  Fri, 08 Apr 2022 16:58:54 +0200

cyclonedds (0.9.0-2) unstable; urgency=medium

  * Set ENABLE_SHM=AUTO
  * Fix unresolved symbol on big-endian architectures

 -- Timo Röhling <roehling@debian.org>  Fri, 08 Apr 2022 13:38:04 +0200

cyclonedds (0.9.0-1) unstable; urgency=medium

  * New upstream version 0.9.0

 -- Timo Röhling <roehling@debian.org>  Thu, 07 Apr 2022 21:11:26 +0200

cyclonedds (0.8.2-6) unstable; urgency=medium

  * Build against iceoryx 2.0, now with armhf support

 -- Timo Röhling <roehling@debian.org>  Thu, 17 Mar 2022 11:37:31 +0100
