=== src/CMakeLists.txt ===
--- 
+++ 
@@ -27,6 +27,7 @@
 option(ENABLE_DEADLINE_MISSED "Enable Deadline Missed QoS support" ON)
 option(ENABLE_NETWORK_PARTITIONS "Enable network partition support" ON)
 option(ENABLE_SOURCE_SPECIFIC_MULTICAST "Enable support for source-specific multicast" ON)
+option(ENABLE_IPV6 "Enable ipv6 support" ON)
 option(ENABLE_TYPE_DISCOVERY "Enable Type Discovery support" OFF)
 option(ENABLE_TOPIC_DISCOVERY "Enable Topic Discovery support" OFF)
 if(ENABLE_TOPIC_DISCOVERY)
